#pragma once
#include "Entity.h"
#include "EntityState.h"
#include "EntityStateFlashEffect.h"
#include "EntityStateInvincible.h"
#include "CS_QuoteGravity.h"
#include "CS_JackFishWater.h"
#include "CS_JackFishControl.h"
#include "CS_JackFishResist.h"
#include "CS_JackFishJump.h"
#include "CS_JackFishStand.h"
#include "CS_JackFishSwim.h"
#include "CS_JackFishFaceToBack.h"
#include "CS_JackFishHurt.h"
#include "CS_JackFishBubbleBeam.h"
#define CS_JACKFISH_CREATENAME L"CS_mychar_jackfish"
//玩家角色 杰克（鱼的形态）
class CS_JackFish :
    public MyCharEntity
{
public:
    CS_JackFish();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void SetState(std::wstring stateName, int lr) override;
	void LoadSaveData() override;//加载保存数据
	void WriteSaveData() override;//写入保存数据
	bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
	void Gain(std::weak_ptr<Entity> item) override;
	void Destroy() override;
	void GetIcon(std::wstring& png, std::wstring& sprite_index, int& image_index, std::set<int>& hideLayerList) override;
	void CrushDeath();
	void CopyFrom(std::shared_ptr<Entity>& another) override;//让自己获得另一个和自己同类型实体一模一样的属性
	//图层显示
	float animation_moveSpeed = 0x200 / ts;
	bool animation_delay = false;//走路动画延迟一帧（对齐到整格）
	float floatSrcX = 0;//悬浮位置
	float floatSrcY = 0;
	//状态模块
	EntityStateFlashEffect stateFlash;
	EntityStateInvincible stateInvincible;
	CS_QuoteGravity stateGravity;
	CS_JackFishWater stateWater;
	CS_JackFishControl stateControl;
	CS_JackFishResist stateResist;
	CS_JackFishJump stateJump;
	CS_JackFishStand stateStand;
	CS_JackFishSwim stateSwim;
	CS_JackFishFaceToBack stateFaceToBack;
	CS_JackFishHurt stateHurt;
	//技能模块
	CS_JackFishBubbleBeam skillBubbleBeam;
	//其他变量
	std::wstring crushEvent;
};

std::shared_ptr<Entity> CreateCS_JackFish();